searchNodes=[{"doc":"Description ExTerm is an terminal Phoenix.LiveView component. ExTerm is responsible for converting erlang IO protocol messages into web output and translating web input into responses in the IO protocol. Installation Add ExTerm to your mix.exs: def deps do [ # ... { :ex_term , &quot;~&gt; 0.2&quot; } # ... ] end How to create a live terminal in your Phoenix router ExTerm provides the convenience helper ExTerm.Router.live_term/3 that you can use to create a live view route. You must supply a Phoenix.PubSub server that is the communication channel to send important updates to the liveview. It's recommended to use the PubSub server associated with your web server. The default backend is ExTerm.TerminalBackend and the default terminal is IEx.Server . Both of these are customizable. with the default backend and default terminal import ExTerm.Router scope &quot;/live_term&quot; do pipe_through :browser live_term &quot;/&quot; , pubsub_server : MyAppWeb.PubSub end with the default backend and a custom interaction layer import ExTerm.Router scope &quot;/live_term&quot; do pipe_through :browser live_term &quot;/&quot; , pubsub_server : MyAppWeb.PubSub , terminal : { __MODULE__ , :function , [ ] } end with a custom backend import ExTerm.Router scope &quot;/live_term&quot; do pipe_through :browser live_term &quot;/&quot; , MyBackend , pubsub_server : MyAppWeb.PubSub end Customizing layout (CSS) You can customize the css for the layout, by providing either a builtin layout option or providing your own. To use a builtin layout, pass the layout name :default or :bw (for black and white console text) as the css option, as follows: live_term &quot;/&quot; , pubsub_server : MyAppWeb.PubSub , css : :bw To use a custom layout, put the layout file in the priv directory of your applicatyon and pass the relative path as follows: live_term &quot;/&quot; , MyBackend , pubsub_server : MyAppWeb.PubSub , css : { :priv , my_app , &quot;path/to/my_layout.css&quot; } Note that this content must be available at compile time.","ref":"ExTerm.html","title":"ExTerm","type":"module"},{"doc":"This behaviour defines the contract that an ExTerm backend must implement to respond to inbound user events.","ref":"ExTerm.Backend.html","title":"ExTerm.Backend","type":"behaviour"},{"doc":"triggered when the terminal loses focus.","ref":"ExTerm.Backend.html#c:on_blur/1","title":"ExTerm.Backend.on_blur/1","type":"callback"},{"doc":"forwarded from the Phoenix.LiveView.mount/3 callback, but only on the second pass when the socket connects. An ExTerm terminal does not display any data until the websocket connection has been established.","ref":"ExTerm.Backend.html#c:on_connect/3","title":"ExTerm.Backend.on_connect/3","type":"callback"},{"doc":"forwarded from the Phoenix.LiveView.handle_event/3 callback. This callback is only invoked for events that aren't handled by the other callbacks. Note This callback should not be implemented unless customizing the terminal in ways that are not currently supported; this is a future placeholder.","ref":"ExTerm.Backend.html#c:on_event/3","title":"ExTerm.Backend.on_event/3","type":"callback"},{"doc":"triggered when the terminal gets focus.","ref":"ExTerm.Backend.html#c:on_focus/1","title":"ExTerm.Backend.on_focus/1","type":"callback"},{"doc":"triggered when the user presses on a key when the terminal has focus. see also https://developer.mozilla.org/en-US/docs/Web/API/Element/keydown_event the key string is corresponds to the KeyboardEvent.key field. for documentation on non-character key strings that can be passed to the callback, see: https://developer.mozilla.org/en-US/docs/Web/API/UI_Events/Keyboard_event_key_values Aside from capitalization of standard characters, it's the backend's responsibility to track modifier keys, for example &quot;Control&quot;","ref":"ExTerm.Backend.html#c:on_keydown/2","title":"ExTerm.Backend.on_keydown/2","type":"callback"},{"doc":"triggered when the user lets go of a key when the terminal has focus. see also https://developer.mozilla.org/en-US/docs/Web/API/Element/keyup_event the key string is corresponds to the KeyboardEvent.key field. for documentation on non-character key strings that can be passed to the callback, see: https://developer.mozilla.org/en-US/docs/Web/API/UI_Events/Keyboard_event_key_values Aside from capitalization of standard characters, it's the backend's responsibility to track modifier keys, for example &quot;Control&quot;","ref":"ExTerm.Backend.html#c:on_keyup/2","title":"ExTerm.Backend.on_keyup/2","type":"callback"},{"doc":"triggered when the user pastes content into the terminal.","ref":"ExTerm.Backend.html#c:on_paste/2","title":"ExTerm.Backend.on_paste/2","type":"callback"},{"doc":"","ref":"ExTerm.Backend.html#t:json/0","title":"ExTerm.Backend.json/0","type":"type"},{"doc":"","ref":"ExTerm.Backend.html#t:params/0","title":"ExTerm.Backend.params/0","type":"type"},{"doc":"","ref":"ExTerm.Backend.html#t:session/0","title":"ExTerm.Backend.session/0","type":"type"},{"doc":"A datastructure which describes in-memory storage of console information. Important Understanding this datastructure and its associated functions is critical to implementing a custom ExTerm backend. Console information consists of the following: buffer of all rows/columns so far. view window sizing metadata. cursor location. current ANSI styling metadata. You may also store custom metadata into console. Console is backed by an ets table. Access functions are designed to operate across a cluster. Note that console is not backed by a process, but it is the responsibility of a process; if that process dies, the console will get destroyed, and by default mutating functions cannot be called from other processes. Inside the table the table contains metadata of the form {atom, term} , and cells of the form {{row, column}, %ExTerm.Console.Cell{}} . The table is sorted on term order; this preserves lexicographical order over the cells, and the metadata precede all of the cells. Note that every row contains an extra &quot;sentinel&quot; cell at the end which needs to be displayed on the console. This sentinel serves to record the length of the row, and also creates line breaks in the terminal div by being a &quot;preformatted&quot; hard return.","ref":"ExTerm.Console.html","title":"ExTerm.Console","type":"module"},{"doc":"returns the number of columns in a given row. Does not include the sentinel in the final count. If the row doesn't exist, returns 0. this function must be in an access transaction","ref":"ExTerm.Console.html#columns/2","title":"ExTerm.Console.columns/2","type":"function"},{"doc":"obtains the cursor metadata this function must be in an access transaction","ref":"ExTerm.Console.html#cursor/1","title":"ExTerm.Console.cursor/1","type":"function"},{"doc":"primitive :ets delete function this function must be in a mutation transaction","ref":"ExTerm.Console.html#delete/2","title":"ExTerm.Console.delete/2","type":"function"},{"doc":"removes a key from the metadata store this function must be in a mutation transaction","ref":"ExTerm.Console.html#delete_metadata/2","title":"ExTerm.Console.delete_metadata/2","type":"function"},{"doc":"returns a full row, in ascending order. May include the sentinel, if with_sentinel? is true (defaults to false ) this function must be in an access transaction","ref":"ExTerm.Console.html#full_row/3","title":"ExTerm.Console.full_row/3","type":"function"},{"doc":"retrieves the cell info (location + cell contents) for the console location this function must be in an access transaction","ref":"ExTerm.Console.html#get/2","title":"ExTerm.Console.get/2","type":"function"},{"doc":"obtains a single key metadata or a list of keys. Note that if you provide a list of keys the values will be returned as a keyword list, in erlang term order of the keys.","ref":"ExTerm.Console.html#get_metadata/2","title":"ExTerm.Console.get_metadata/2","type":"function"},{"doc":"returns if a location is present in the console this function must be in an access transaction","ref":"ExTerm.Console.html#has?/2","title":"ExTerm.Console.has?/2","type":"function"},{"doc":"primitive :ets insert function this function must be in a mutation transaction","ref":"ExTerm.Console.html#insert/2","title":"ExTerm.Console.insert/2","type":"function"},{"doc":"inserts iodata at a certain row. This will &quot;push down&quot; as many lines as is necessary to insert the iodata. If the current cursor precedes the insertion point, it will be unaffected. If the current cursor is after the insertion point, it will be displaced as many lines as are necessary this function must be in an mutation transaction","ref":"ExTerm.Console.html#insert_iodata/3","title":"ExTerm.Console.insert_iodata/3","type":"function"},{"doc":"primitive :ets last function this function must be in an access transaction","ref":"ExTerm.Console.html#last/1","title":"ExTerm.Console.last/1","type":"function"},{"doc":"returns the last location on the console. Does NOT include the sentinel. There is always guaranteed to be a sentinel on the end of the cell. If the table is empty and only contains metadata, returns {0, 0} this function must be in an access transaction","ref":"ExTerm.Console.html#last_cell/1","title":"ExTerm.Console.last_cell/1","type":"function"},{"doc":"returns true if the cell exists and the location is on the last column of its row, not inclusive of the sentinel. Note this returns false if it's the sentinel. this function must be in an access transaction","ref":"ExTerm.Console.html#last_column?/2","title":"ExTerm.Console.last_column?/2","type":"function"},{"doc":"obtains the layout metadata this function must be in an access transaction","ref":"ExTerm.Console.html#layout/1","title":"ExTerm.Console.layout/1","type":"function"},{"doc":"primitive :ets lookup function this function must be in an access transaction","ref":"ExTerm.Console.html#lookup/2","title":"ExTerm.Console.lookup/2","type":"function"},{"doc":"","ref":"ExTerm.Console.html#move_cursor/2","title":"ExTerm.Console.move_cursor/2","type":"function"},{"doc":"initalizes a new console. The argument, which should be a keyword list, will be put into the console metadata.","ref":"ExTerm.Console.html#new/1","title":"ExTerm.Console.new/1","type":"function"},{"doc":"inserts a new row into the console, either at a given location, given by an integer, or at the end, given by :end atom. this function must be in a mutation transaction","ref":"ExTerm.Console.html#new_row/2","title":"ExTerm.Console.new_row/2","type":"function"},{"doc":"puts a single cell onto the console, using absolute row position. Does not change the cursor location. this function must be in a mutation transaction","ref":"ExTerm.Console.html#put_cell/3","title":"ExTerm.Console.put_cell/3","type":"function"},{"doc":"inserts iodata at the location of a cursor. this function must be in an mutation transaction","ref":"ExTerm.Console.html#put_iodata/2","title":"ExTerm.Console.put_iodata/2","type":"function"},{"doc":"puts multiple k/v into the metadata store (as a keyword list) this function must be in a mutation transaction","ref":"ExTerm.Console.html#put_metadata/2","title":"ExTerm.Console.put_metadata/2","type":"function"},{"doc":"puts a single k/v into the metadata store this function must be in a mutation transaction","ref":"ExTerm.Console.html#put_metadata/3","title":"ExTerm.Console.put_metadata/3","type":"function"},{"doc":"primitive :ets select function this function must be in an access transaction","ref":"ExTerm.Console.html#select/2","title":"ExTerm.Console.select/2","type":"function"},{"doc":"primitive :ets select_count function this function must be in an access transaction","ref":"ExTerm.Console.html#select_count/2","title":"ExTerm.Console.select_count/2","type":"function"},{"doc":"primitive :ets select function that selects cells from a location inclusive this function must be in an access transaction","ref":"ExTerm.Console.html#select_from/2","title":"ExTerm.Console.select_from/2","type":"function"},{"doc":"obtains the style metadata this function must be in an access transaction","ref":"ExTerm.Console.html#style/1","title":"ExTerm.Console.style/1","type":"function"},{"doc":"the contents of the &quot;cells&quot; section of the table.","ref":"ExTerm.Console.html#t:cellinfo/0","title":"ExTerm.Console.cellinfo/0","type":"type"},{"doc":"the layout of the console, which should corresppond to the number of rows and columns in the primary view of the console in html.","ref":"ExTerm.Console.html#t:layout/0","title":"ExTerm.Console.layout/0","type":"type"},{"doc":"coordinate information for a character in the console.","ref":"ExTerm.Console.html#t:location/0","title":"ExTerm.Console.location/0","type":"type"},{"doc":"descriptor for a console, which stores a the permission information, a reference to the table, and a write semaphore (if the table is public)","ref":"ExTerm.Console.html#t:t/0","title":"ExTerm.Console.t/0","type":"opaque"},{"doc":"Contains macros which help write concise code for ExTerm.Console access.","ref":"ExTerm.Console.Helpers.html","title":"ExTerm.Console.Helpers","type":"module"},{"doc":"creates a function that is tagged as an access function. The associated console must be the first argument in the arguments list. Generally, if you use the ExTerm.Console functions you won't need to use this macro, but if you want to write your own primitives that wrap :ets access functions, you should write the function using this macro. If the application environment variable :ex_term, :check_transaction is set, and the function is not inside of a transaction, it will raise with an error. If you're developing exterm backends, you should have this environment variable set at a minimum in dev and test environments.","ref":"ExTerm.Console.Helpers.html#defaccess/2","title":"ExTerm.Console.Helpers.defaccess/2","type":"macro"},{"doc":"creates a function that is tagged as a mutation. The associated console must be the first argument in the arguments list. Generally, if you use the ExTerm.Console functions you won't need to use this macro, but if you want to write your own primitives that wrap :ets mutation functions, you should write the function using this macro. If the application environment variable :ex_term, :check_transaction is set, and the function is not inside of a transaction, it will raise with an error. If you're developing exterm backends, you should have this environment variable set at a minimum in dev and test environments.","ref":"ExTerm.Console.Helpers.html#defmutate/2","title":"ExTerm.Console.Helpers.defmutate/2","type":"macro"},{"doc":"wraps code into a single execution unit that are run on the same node. note that there are two types: :mutate and :access types. all code in :mutate is guaranteed to be truly transactional with respect to the ets table with respect to other code guarded by this transaction macro. code bundled in the :access type is not guaranteed to be transactional with respect to the ets table. For mutations, this also dispatches the update function based on the lambda stored in the ExTerm.Console table.","ref":"ExTerm.Console.Helpers.html#transaction/3","title":"ExTerm.Console.Helpers.transaction/3","type":"macro"},{"doc":"struct describing console changes. These updates will be broadcast to liveviews (or any other processes) that listen in console updates. Typically this update will be automatically issued by Console functions, but the struct is documented here so that receiving processes can be aware of what messages are coming in.","ref":"ExTerm.Console.Update.html","title":"ExTerm.Console.Update","type":"module"},{"doc":"records changing the cursor into update. Does not add this into the chnages list due to the fact that the cursor may change again before the update needs to be dispatched. The cursor position may be added prior to dispatch using merge_cursor/1","ref":"ExTerm.Console.Update.html#change_cursor/1","title":"ExTerm.Console.Update.change_cursor/1","type":"function"},{"doc":"obtains the cells from a console datastructure corresponding to the :changes field.","ref":"ExTerm.Console.Update.html#get/2","title":"ExTerm.Console.Update.get/2","type":"function"},{"doc":"identifies if a term is a end_range/0 Optimized to distinguish between t:Console.location/0 , cell_range/0 , and end_range/0 . May not correctly type other terms. iex&gt; alias ExTerm.Console.Update iex&gt; Update . is_end_range ( { 1 , 2 } ) false iex&gt; Update . is_end_range ( { { 1 , 1 } , { 1 , 2 } } ) false iex&gt; Update . is_end_range ( { { 1 , 1 } , { 1 , :end } } ) false iex&gt; Update . is_end_range ( { { 1 , 1 } , :end } ) true","ref":"ExTerm.Console.Update.html#is_end_range/1","title":"ExTerm.Console.Update.is_end_range/1","type":"macro"},{"doc":"identifies if a term is a t:Console.location/0 Optimized to distinguish between t:Console.location/0 , cell_range/0 , and end_range/0 . May not correctly type other terms. iex&gt; alias ExTerm.Console.Update iex&gt; Update . is_location ( { 1 , 2 } ) true iex&gt; Update . is_location ( { { 1 , 1 } , { 1 , 2 } } ) false iex&gt; Update . is_location ( { { 1 , 1 } , { 1 , :end } } ) false iex&gt; Update . is_location ( { { 1 , 1 } , :end } ) false","ref":"ExTerm.Console.Update.html#is_location/1","title":"ExTerm.Console.Update.is_location/1","type":"macro"},{"doc":"identifies if a term is a cell_range/0 Optimized to distinguish between t:Console.location/0 , cell_range/0 , and end_range/0 . May not correctly type other terms. iex&gt; alias ExTerm.Console.Update iex&gt; Update . is_range ( { 1 , 2 } ) false iex&gt; Update . is_range ( { { 1 , 1 } , { 1 , 2 } } ) true iex&gt; Update . is_range ( { { 1 , 1 } , { 1 , :end } } ) true iex&gt; Update . is_range ( { { 1 , 1 } , :end } ) false","ref":"ExTerm.Console.Update.html#is_range/1","title":"ExTerm.Console.Update.is_range/1","type":"macro"},{"doc":"merges an update struct into the merge struct that is waiting in the process dictionary","ref":"ExTerm.Console.Update.html#merge/1","title":"ExTerm.Console.Update.merge/1","type":"function"},{"doc":"To be used when tracking update changes in a custom fashion bypassing updates separate from the process dictionary. Should always be succeeded by merge/2 , which will merge these separate updates into the process dictionary","ref":"ExTerm.Console.Update.html#merge_changes/2","title":"ExTerm.Console.Update.merge_changes/2","type":"function"},{"doc":"merges the cursor location into the changes; this should be the last step before sending the update message.","ref":"ExTerm.Console.Update.html#merge_cursor/1","title":"ExTerm.Console.Update.merge_cursor/1","type":"function"},{"doc":"adds a cell change or set of cell changes into the update that is stored in the current process dictionary.","ref":"ExTerm.Console.Update.html#register_cell_change/2","title":"ExTerm.Console.Update.register_cell_change/2","type":"function"},{"doc":"records a range to declare as the insertion range","ref":"ExTerm.Console.Update.html#set_insertion/1","title":"ExTerm.Console.Update.set_insertion/1","type":"function"},{"doc":"","ref":"ExTerm.Console.Update.html#t:cell_change/0","title":"ExTerm.Console.Update.cell_change/0","type":"type"},{"doc":"","ref":"ExTerm.Console.Update.html#t:cell_changes/0","title":"ExTerm.Console.Update.cell_changes/0","type":"type"},{"doc":"","ref":"ExTerm.Console.Update.html#t:cell_range/0","title":"ExTerm.Console.Update.cell_range/0","type":"type"},{"doc":"","ref":"ExTerm.Console.Update.html#t:end_range/0","title":"ExTerm.Console.Update.end_range/0","type":"type"},{"doc":"","ref":"ExTerm.Console.Update.html#t:row_end/0","title":"ExTerm.Console.Update.row_end/0","type":"type"},{"doc":"struct which describes the update information fields cursor : nil if there is no change in the cursor location, new cursor t:Console.location/0 otherwise. insertion : nil if no rows have been inserted, a range if the insertion has come about due to an insert_iodata instruction cells : A list of changes to the console data. This is a list of one of the following types single t:Console.location/0 . This indicates a single location has changed. location range, represented by a {begin, end} twople of t:Console.location/0 . This indicates multiple consecutive locations have changed in the range between begin and end locations. This is allowed to span multiple lines. location range with end-of-line, represented by a twople of t:Console.location/0 and {row, :end} . This should be used in lieu of a single location if the location is the last character on the line, OR if a location range ends at last character on the line. location range with end-of-console, reppresnted by a twople of t:Console.location/0 and :end . Note that the cells should be in reverse-sorted order, and should be compacted.","ref":"ExTerm.Console.Update.html#t:t/0","title":"ExTerm.Console.Update.t/0","type":"type"},{"doc":"behaviour template for implementing a server which responds to Robert Virding's IO Protocol: https://www.erlang.org/doc/apps/stdlib/io_protocol.html Warning This module may be broken out into its own library in the future.","ref":"ExTerm.IOServer.html","title":"ExTerm.IOServer","type":"behaviour"},{"doc":"responds to {:get_geometry, geometry} requests, where geometry may be either :rows or :columns This request expects a reply of integer or {:error, error} in one of the following ways: {:error, error, state} return value {:reply, reply, state, ...} return value {:noreply, state, ...} return followed by reply(from, reply) asynchronously.","ref":"ExTerm.IOServer.html#c:handle_geometry/3","title":"ExTerm.IOServer.handle_geometry/3","type":"callback"},{"doc":"responds to :get_until , :get_chars , and :get_line requests in a single interface. These requests constitute: {:get_until, encoding, prompt, module, function, extraargs} {:get_chars, encoding, prompt, count} {:get_line, encoding, prompt} The get_condition is packaged in the following ways: for :get_until , it is passed as {:until, {module, function, args}} . for :get_chars , it is passed as {:chars, count} for :get_line , it is passed as :line This request expects a reply of data :eof or {:error, error} in one of the following ways: {:error, error, state} return value {:reply, reply, state, ...} return value {:noreply, state, ...} return followed by reply(from, reply) asynchronously. Tip Typically for this function, an asynchronous response is expected.","ref":"ExTerm.IOServer.html#c:handle_get/5","title":"ExTerm.IOServer.handle_get/5","type":"callback"},{"doc":"responds to :getopts requests. This request expects a reply of keywordlist or {:error, error} in one of the following ways: {:error, error, state} return value {:reply, reply, state, ...} return value {:noreply, state, ...} return followed by reply(from, reply) asynchronously.","ref":"ExTerm.IOServer.html#c:handle_getopts/2","title":"ExTerm.IOServer.handle_getopts/2","type":"callback"},{"doc":"responds to other messages. Since IOServer takes over the GenServer.handle_info/2 callback, this callback can be used to listen to other messages.","ref":"ExTerm.IOServer.html#c:handle_message/2","title":"ExTerm.IOServer.handle_message/2","type":"callback"},{"doc":"responds to {:put_chars, encoding, characters} and {:put_chars, encoding, module, function, args} requests. In the case module , function and args are provided, these are merged into a single tuple and passed as the second parameter. This request expects a reply of :ok or {:error, error} in one of the following ways: {:ok, state} return value {:error, error, state} return value {:reply, reply, state, ...} return value {:noreply, state, ...} return followed by reply(from, reply) asynchronously.","ref":"ExTerm.IOServer.html#c:handle_put/4","title":"ExTerm.IOServer.handle_put/4","type":"callback"},{"doc":"responds to other requests, these may not be defined at the time and may come in a future IO protocol spec. A default implementation is provided which emits an standard response for forwards compatibility.","ref":"ExTerm.IOServer.html#c:handle_request/3","title":"ExTerm.IOServer.handle_request/3","type":"callback"},{"doc":"responds to {:setopts, options} requests. This request expects a reply of :ok or {:error, error} in one of the following ways: {:ok, state} return value {:error, error, state} return value {:reply, reply, state, ...} return value {:noreply, state, ...} return followed by reply(from, reply) asynchronously.","ref":"ExTerm.IOServer.html#c:handle_setopts/3","title":"ExTerm.IOServer.handle_setopts/3","type":"callback"},{"doc":"","ref":"ExTerm.IOServer.html#reply/2","title":"ExTerm.IOServer.reply/2","type":"function"},{"doc":"","ref":"ExTerm.IOServer.html#t:basic_reply/0","title":"ExTerm.IOServer.basic_reply/0","type":"type"},{"doc":"","ref":"ExTerm.IOServer.html#t:basic_response/0","title":"ExTerm.IOServer.basic_response/0","type":"type"},{"doc":"","ref":"ExTerm.IOServer.html#t:encoding/0","title":"ExTerm.IOServer.encoding/0","type":"type"},{"doc":"","ref":"ExTerm.IOServer.html#t:from/0","title":"ExTerm.IOServer.from/0","type":"type"},{"doc":"","ref":"ExTerm.IOServer.html#t:geometry/0","title":"ExTerm.IOServer.geometry/0","type":"type"},{"doc":"","ref":"ExTerm.IOServer.html#t:get_condition/0","title":"ExTerm.IOServer.get_condition/0","type":"type"},{"doc":"","ref":"ExTerm.IOServer.html#t:get_reply/0","title":"ExTerm.IOServer.get_reply/0","type":"type"},{"doc":"","ref":"ExTerm.IOServer.html#t:mfargs/0","title":"ExTerm.IOServer.mfargs/0","type":"type"},{"doc":"","ref":"ExTerm.IOServer.html#t:noreply/0","title":"ExTerm.IOServer.noreply/0","type":"type"},{"doc":"","ref":"ExTerm.IOServer.html#t:opt/0","title":"ExTerm.IOServer.opt/0","type":"type"},{"doc":"","ref":"ExTerm.IOServer.html#t:opts/0","title":"ExTerm.IOServer.opts/0","type":"type"},{"doc":"","ref":"ExTerm.IOServer.html#t:reply/1","title":"ExTerm.IOServer.reply/1","type":"type"},{"doc":"","ref":"ExTerm.IOServer.html#t:response/1","title":"ExTerm.IOServer.response/1","type":"type"},{"doc":"","ref":"ExTerm.IOServer.html#t:state/0","title":"ExTerm.IOServer.state/0","type":"type"},{"doc":"","ref":"ExTerm.IOServer.html#t:stop/1","title":"ExTerm.IOServer.stop/1","type":"type"},{"doc":"Plug that marshals ExTerm options to be put in the session store. by placing options in the session, it's possible for the initial html render and the socket-connected liveview to share common parameters. This module also provides the helper function live_term/3 which wraps calling the plug (with options) and calling the Phoenix.LiveView.Router.live/4 macro into one directive.","ref":"ExTerm.Router.html","title":"ExTerm.Router","type":"module"},{"doc":"creates an ExTerm live terminal route, inside of a Phoenix Router You must supply a path, and optionally a backend module. Basic Usage The following code creates a router with the default ExTerm.TerminalBackend backend: defmodule MyAppWeb.Router do use MyAppWeb , :router import ExTerm.Router pipeline :browser do plug :accepts , [ &quot;html&quot; ] plug :fetch_session plug :fetch_live_flash plug :put_root_layout , { MyAppWeb.LayoutView , :root } plug :protect_from_forgery plug :put_secure_browser_headers end import ExTerm.Router scope &quot;/live_term&quot; do pipe_through :browser live_term &quot;/terminal&quot; , pubsub_server : MyAppWeb.PubSub end end Alternative backends If you would like to specify an alternative backend, you may provide this as a second parameter, which must be a module. Other backends There are currently no other backends shipped with :ex_term but backends to interface with other CLIs may be forthcoming. scope &quot;/live_term&quot; , MyBackend , pubsub_server : MyAppWeb.PubSub Options Required options :pubsub_server A Phoenix.Pubsub server that will be used for Terminal backends to communicate back to the LiveView. Optional options :layout A twople of postive integers which specify the dimensions of the viewable console space. :css may be an atom or {:priv, app, file_path} . if an atom, may be :default or :bw , which are the builtin css files. if a :priv tuple, at compile-time it will search the priv directory of the supplied application at the specified file_path to obtain the css file. For documentation for backend-specific options, see ExTerm.TerminalBackend","ref":"ExTerm.Router.html#live_term/3","title":"ExTerm.Router.live_term/3","type":"macro"},{"doc":"Default backend that creates a ExTerm.IoServer process and forwards all callbacks to its wrapping module. By default, this is set to ExTerm.TerminalBackend.IoServer . TerminalBackend specific options: This option can be set in the router declaration (see ExTerm.Router ) :io_server a module, should be a supervisable GenServer which satisfies a minimal set of ExTerm.IoServer callbacks. The required implementations are as follows: list coming in v 0.3.0 Example live_term &quot;/&quot; , pubsub_server : MyWebApp.PubSub , io_server : MyIoServer TerminalBackend.IoServer specific This option can be set in the router declaration (see ExTerm.Router ) :terminal a (module, function, args) for the function that should be run inside of the terminal task. This should be a REPL that takes over the task, and typically will be an infinite loop (return type no_return ). If the function terminates, the io server will suffer a fatal error and the terminal liveview will be rendered unusable. Example live_term &quot;/&quot; , pubsub_server : MyWebApp.PubSub , terminal : { MyModule , :run , [ ] }","ref":"ExTerm.TerminalBackend.html","title":"ExTerm.TerminalBackend","type":"module"},{"doc":"ExTerm is an terminal Phoenix.LiveView component. ExTerm is responsible for converting erlang IO protocol messages into web output and translating web input into responses in the IO protocol.","ref":"readme.html","title":"ExTerm","type":"extras"},{"doc":"Add ExTerm to your mix.exs: def deps do [ # ... { :ex_term , &quot;~&gt; 0.2&quot; } # ... ] end def deps do [ # ... { :ex_term , &quot;~&gt; 0.2&quot; } # ... ] end How to create a live terminal in your Phoenix router You must supply a Phoenix.PubSub server that is the communication channel to send important updates to the liveview. It's recommended to use the PubSub server associated with your web server. import ExTerm.Router scope &quot;/live_term&quot; do pipe_through :browser live_term &quot;/&quot; , pubsub_server : MyAppWeb.PubSub end","ref":"readme.html#installation","title":"ExTerm - Installation","type":"extras"},{"doc":"Documentation is available on hexdocs.pm: https://hexdocs.pm/ex_term Planned (Pro?) features: provenance tracking multiplayer mode","ref":"readme.html#documentation","title":"ExTerm - Documentation","type":"extras"}]